function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var React = _interopDefault(require('react'));

var isObject = function isObject(o) {
  return o !== null && typeof o === 'object';
};

var valueOf = function valueOf(object, key) {
  if (object === null || object[key] === null) {
    return '';
  }

  return String(object[key]);
};

var defaultStyles = {
  form: {
    display: 'flex',
    flexFlow: 'row wrap',
    justifyContent: 'space-around',
    alignItems: 'stretch',
    alignContent: 'space-around'
  },
  label: {
    display: 'block',
    fontWeight: '900',
    lineHeight: '1.5rem'
  },
  value: {
    lineHeight: '1.5rem',
    backgroundColor: 'white',
    border: '1px solid #cacaca',
    borderRadius: '2px',
    padding: '0.1rem 0.25rem'
  },
  field: {
    flexGrow: '1',
    display: 'flex',
    flexFlow: 'column wrap',
    justifyContent: 'space-around',
    alignItems: 'stretch',
    alignContent: 'space-around',
    border: '1px solid rgba(0,0,0,.1)',
    borderRadius: '4px',
    padding: '0.25rem',
    margin: '0.25rem',
    backgroundColor: 'rgba(0,0,0,.03)'
  }
};
var JSONViewer = function JSONViewer(_ref) {
  var _ref$data = _ref.data,
      data = _ref$data === void 0 ? {} : _ref$data,
      _ref$styles = _ref.styles,
      styles = _ref$styles === void 0 ? defaultStyles : _ref$styles;
  return /*#__PURE__*/React.createElement("div", {
    style: styles.form
  }, Object.keys(data).map(function (key) {
    return /*#__PURE__*/React.createElement("div", {
      key: key,
      style: styles.field
    }, /*#__PURE__*/React.createElement("label", {
      style: styles.label
    }, key), data && isObject(data[key]) ? /*#__PURE__*/React.createElement(JSONViewer, {
      data: data && data[key] || {}
    }) : valueOf(data, key).length <= 140 ? /*#__PURE__*/React.createElement("input", {
      type: "text",
      value: valueOf(data, key),
      readOnly: true,
      style: styles.value
    }) : /*#__PURE__*/React.createElement("textarea", {
      rows: Math.min(20, valueOf(data, key).split('\n').length + 1),
      cols: 40,
      value: valueOf(data, key),
      readOnly: true,
      style: styles.value
    }));
  }));
};

exports.JSONViewer = JSONViewer;
exports.defaultStyles = defaultStyles;
//# sourceMappingURL=index.js.map
